;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKOAuthToken1')
    ALTER TABLE OAuthToken DROP CONSTRAINT FKOAuthToken1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKParam1')
    ALTER TABLE Param DROP CONSTRAINT FKParam1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKFeature1')
    ALTER TABLE Feature DROP CONSTRAINT FKFeature1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKSharedData1')
    ALTER TABLE SharedData DROP CONSTRAINT FKSharedData1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKPreference1')
    ALTER TABLE Preference DROP CONSTRAINT FKPreference1;

;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKPreferenceDefault1')
    ALTER TABLE PreferenceDefault DROP CONSTRAINT FKPreferenceDefault1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKWidgetInstance1')
    ALTER TABLE WidgetInstance DROP CONSTRAINT FKWidgetInstance1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKStartFile1')
    ALTER TABLE StartFile DROP CONSTRAINT FKStartFile1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKDescription1')
    ALTER TABLE Description DROP CONSTRAINT FKDescription1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKAuthor1')
    ALTER TABLE Author DROP CONSTRAINT FKAuthor1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKName1')
    ALTER TABLE Name DROP CONSTRAINT FKName1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKLicense1')
    ALTER TABLE License DROP CONSTRAINT FKLicense1;

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'RI' AND name = 'FKWidgetIcon1')
    ALTER TABLE WidgetIcon DROP CONSTRAINT FKWidgetIcon1;

;

;

/* ----------------------------------------------------------------------- */
/* OAuthToken */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'OAuthToken')
BEGIN
    DROP TABLE OAuthToken
END;

/* ----------------------------------------------------------------------- */
/* Param */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Param')
BEGIN
    DROP TABLE Param
END;

/* ----------------------------------------------------------------------- */
/* Feature */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Feature')
BEGIN
    DROP TABLE Feature
END;

/* ----------------------------------------------------------------------- */
/* SharedData */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'SharedData')
BEGIN
    DROP TABLE SharedData
END;

/* ----------------------------------------------------------------------- */
/* Preference */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Preference')
BEGIN
    DROP TABLE Preference
END;

/* ----------------------------------------------------------------------- */
/* Participant */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Participant')
BEGIN
    DROP TABLE Participant
END;

/* ----------------------------------------------------------------------- */
/* PreferenceDefault */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'PreferenceDefault')
BEGIN
    DROP TABLE PreferenceDefault
END;

/* ----------------------------------------------------------------------- */
/* WidgetInstance */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'WidgetInstance')
BEGIN
    DROP TABLE WidgetInstance
END;

/* ----------------------------------------------------------------------- */
/* StartFile */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'StartFile')
BEGIN
    DROP TABLE StartFile
END;

/* ----------------------------------------------------------------------- */
/* Description */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Description')
BEGIN
    DROP TABLE Description
END;

/* ----------------------------------------------------------------------- */
/* Author */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Author')
BEGIN
    DROP TABLE Author
END;

/* ----------------------------------------------------------------------- */
/* Name */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Name')
BEGIN
    DROP TABLE Name
END;

/* ----------------------------------------------------------------------- */
/* License */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'License')
BEGIN
    DROP TABLE License
END;

/* ----------------------------------------------------------------------- */
/* WidgetIcon */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'WidgetIcon')
BEGIN
    DROP TABLE WidgetIcon
END;

/* ----------------------------------------------------------------------- */
/* Widget */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'Widget')
BEGIN
    DROP TABLE Widget
END;

/* ----------------------------------------------------------------------- */
/* OPENJPA_SEQUENCE_TABLE */
/* ----------------------------------------------------------------------- */

;

IF EXISTS (SELECT 1 FROM sysobjects WHERE type = 'U' AND name = 'OPENJPA_SEQUENCE_TABLE')
BEGIN
    DROP TABLE OPENJPA_SEQUENCE_TABLE
END;

/* ----------------------------------------------------------------------- */
/* OPENJPA_SEQUENCE_TABLE */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE OPENJPA_SEQUENCE_TABLE
(
    ID SMALLINT NOT NULL,
    SEQUENCE_VALUE DECIMAL(19,0) NULL,
    PRIMARY KEY (ID)
);

/* ----------------------------------------------------------------------- */
/* Widget */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Widget
(
    id INT NOT NULL,
    jpa_version INT NULL,
    package_path VARCHAR(255) NULL,
    default_locale VARCHAR(255) NULL,
    height INT NULL,
    width INT NULL,
    guid VARCHAR(255) NOT NULL,
    update_location TEXT NULL,
    widget_version VARCHAR(255) NULL,
    dir VARCHAR(255) NULL,
    lang VARCHAR(255) NULL,
    PRIMARY KEY (id)
);

CREATE UNIQUE INDEX UNWidget1 ON Widget (guid);

/* ----------------------------------------------------------------------- */
/* WidgetIcon */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE WidgetIcon
(
    id INT NOT NULL,
    jpa_version INT NULL,
    src TEXT NULL,
    height INT NULL,
    width INT NULL,
    lang VARCHAR(255) NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXWidgetIcon1 ON WidgetIcon (widget_id);

/* ----------------------------------------------------------------------- */
/* License */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE License
(
    id INT NOT NULL,
    jpa_version INT NULL,
    href TEXT NULL,
    text TEXT NULL,
    dir VARCHAR(255) NULL,
    lang VARCHAR(255) NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXLicense1 ON License (widget_id);

/* ----------------------------------------------------------------------- */
/* Name */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Name
(
    id INT NOT NULL,
    jpa_version INT NULL,
    name TEXT NULL,
    shortName VARCHAR(255) NULL,
    dir VARCHAR(255) NULL,
    lang VARCHAR(255) NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXName1 ON Name (widget_id);

/* ----------------------------------------------------------------------- */
/* Author */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Author
(
    id INT NOT NULL,
    jpa_version INT NULL,
    author TEXT NULL,
    email TEXT NULL,
    href TEXT NULL,
    lang VARCHAR(255) NULL,
    dir VARCHAR(255) NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXAuthor1 ON Author (widget_id);

/* ----------------------------------------------------------------------- */
/* Description */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Description
(
    id INT NOT NULL,
    jpa_version INT NULL,
    content TEXT NULL,
    dir VARCHAR(255) NULL,
    lang VARCHAR(255) NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXDescription1 ON Description (widget_id);

/* ----------------------------------------------------------------------- */
/* StartFile */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE StartFile
(
    id INT NOT NULL,
    jpa_version INT NULL,
    url TEXT NULL,
    charset VARCHAR(255) NULL,
    lang VARCHAR(255) NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXStartFile1 ON StartFile (widget_id);

/* ----------------------------------------------------------------------- */
/* WidgetInstance */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE WidgetInstance
(
    id INT NOT NULL,
    jpa_version INT NULL,
    apikey VARCHAR(255) NOT NULL,
    userId VARCHAR(255) NOT NULL,
    sharedDataKey VARCHAR(255) NULL,
    nonce VARCHAR(255) NULL,
    idKey VARCHAR(255) NOT NULL,
    opensocialToken TEXT NOT NULL,
    widget_id INT NOT NULL,
    updated CHAR(1) NULL,
    shown CHAR(1) NULL,
    hidden CHAR(1) NULL,
    locked CHAR(1) NULL,
    lang VARCHAR(255) NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXWidgetInstance1 ON WidgetInstance (widget_id);

CREATE UNIQUE INDEX UNWidgetInstance1 ON WidgetInstance (idKey);

/* ----------------------------------------------------------------------- */
/* PreferenceDefault */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE PreferenceDefault
(
    id INT NOT NULL,
    jpa_version INT NULL,
    widget_id INT NULL,
    preference VARCHAR(255) NOT NULL,
    value VARCHAR(1024) NOT NULL,
    readOnly CHAR(1) NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXPreferenceDefault1 ON PreferenceDefault (widget_id);

/* ----------------------------------------------------------------------- */
/* Participant */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Participant
(
    id INT NOT NULL,
    jpa_version INT NULL,
    participant_id VARCHAR(255) NOT NULL,
    participant_display_name VARCHAR(255) NOT NULL,
    participant_thumbnail_url VARCHAR(1024) NULL,
    sharedDataKey VARCHAR(255) NOT NULL,
    role VARCHAR(255) NULL,
    PRIMARY KEY (id)
);

/* ----------------------------------------------------------------------- */
/* Preference */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Preference
(
    id INT NOT NULL,
    jpa_version INT NULL,
    widget_instance_id INT NULL,
    dkey VARCHAR(255) NULL,
    dvalue TEXT NULL,
    readOnly CHAR(1) NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXPreference1 ON Preference (widget_instance_id);

CREATE UNIQUE INDEX UNPreference1 ON Preference (widget_instance_id, dkey);

/* ----------------------------------------------------------------------- */
/* SharedData */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE SharedData
(
    id INT NOT NULL,
    jpa_version INT NULL,
    sharedDataKey VARCHAR(255) NULL,
    dkey VARCHAR(255) NULL,
    dvalue TEXT NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXSharedData1 ON SharedData (widget_id);

/* ----------------------------------------------------------------------- */
/* Feature */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Feature
(
    id INT NOT NULL,
    jpa_version INT NULL,
    featureName VARCHAR(255) NOT NULL,
    required CHAR(1) NULL,
    widget_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXFeature1 ON Feature (widget_id);

/* ----------------------------------------------------------------------- */
/* Param */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE Param
(
    id INT NOT NULL,
    jpa_version INT NULL,
    feature_id INT NULL,
    parameterName VARCHAR(255) NOT NULL,
    parameterValue VARCHAR(255) NOT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXParam1 ON Param (feature_id);

/* ----------------------------------------------------------------------- */
/* OAuthToken */
/* ----------------------------------------------------------------------- */

;

CREATE TABLE OAuthToken
(
    id INT NOT NULL,
    jpa_version INT NULL,
    authzUrl VARCHAR(255) NOT NULL,
    accessToken VARCHAR(255) NOT NULL,
    clientId VARCHAR(255) NOT NULL,
    expires DECIMAL(19,0) NOT NULL,
    widget_instance_id INT NULL,
    PRIMARY KEY (id)
);

CREATE INDEX IXOAuthToken1 ON OAuthToken (widget_instance_id);

ALTER TABLE WidgetIcon
    ADD CONSTRAINT FKWidgetIcon1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE License
    ADD CONSTRAINT FKLicense1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Name
    ADD CONSTRAINT FKName1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Author
    ADD CONSTRAINT FKAuthor1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Description
    ADD CONSTRAINT FKDescription1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE StartFile
    ADD CONSTRAINT FKStartFile1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE WidgetInstance
    ADD CONSTRAINT FKWidgetInstance1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE PreferenceDefault
    ADD CONSTRAINT FKPreferenceDefault1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Preference
    ADD CONSTRAINT FKPreference1 FOREIGN KEY (widget_instance_id) REFERENCES WidgetInstance (id);

ALTER TABLE SharedData
    ADD CONSTRAINT FKSharedData1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Feature
    ADD CONSTRAINT FKFeature1 FOREIGN KEY (widget_id) REFERENCES Widget (id);

ALTER TABLE Param
    ADD CONSTRAINT FKParam1 FOREIGN KEY (feature_id) REFERENCES Feature (id);

ALTER TABLE OAuthToken
    ADD CONSTRAINT FKOAuthToken1 FOREIGN KEY (widget_instance_id) REFERENCES WidgetInstance (id);

